
// (c) COPYRIGHT URI/MIT 1996
// Please read the full copyright statement in the file COPYRIGHT.
//
// Authors:
//	reza		Reza Nekovei (reza@intcomm.net)

// DSP sub-class implementation for DSPByte,...DSPGrid.
// The files are patterned after the subcalssing examples 
// Test<type>.c,h files.
//
// ReZa 8/25/96

#include "config_dsp.h"

static char rcsid[] not_used ={"$Id: DSPGrid.cc,v 1.5 2000/10/09 21:24:59 jimg Exp $"};

#include <string>

#include "InternalErr.h"
#include "DSPGrid.h"

Grid *
NewGrid(const string &n)
{
    return new DSPGrid(n);
}

// protected

BaseType *
DSPGrid::ptr_duplicate()
{
    return new DSPGrid(*this);
}

// public

DSPGrid::DSPGrid(const string &n) : Grid(n)
{
}

DSPGrid::~DSPGrid()
{
}

// read() should throw an Error or an InternalErr to indicate a problem with
// the read. The return value indicates that (true) more data needs to be
// read or (false) that all data was read.
bool
DSPGrid::read(const string &dataset)
{
    bool status;

    if (read_p()) // nothing to do
        return false;

    // read array elements
    if (!(status = array_var()->read(dataset))) 
        return status;

    // read maps elements
    for (Pix p = first_map_var(); p; next_map_var(p)) {
	if(!(status = map_var(p)->read(dataset)))
            break;
    }

    if (!status) 
	set_read_p(true);

    return status;
}

// $Log: DSPGrid.cc,v $
// Revision 1.5  2000/10/09 21:24:59  jimg
// Moved CVS Log entries to the end of each file.
// Changed the definition of the read method to match the dap library.
// Added exceptions to the read methods.
// Added code to catch exceptions in dsp_das, _dds and _dods.
//
// Revision 1.4  1999/04/30 21:32:46  jimg
// Merged no-gnu and release-2-17
//
// Revision 1.3.4.1  1999/02/10 06:28:57  brent
// convert to Standard C++ strings -- b^2
//
// Revision 1.3  1998/08/06 16:32:08  jimg
// Fixed misuse of the read(...) member function. Return true if more data
// is to be read, false is if not and error if an error is detected
//
// Revision 1.2  1996/11/15 18:22:17  jimg
// Fixed copyright statement.
// Added include of config header
//
// Revision 1.1  1996/09/18 22:42:02  reza
//  First release of DODS-DSP servers.
//
